<?php

/*
	=====================================================
	ExpressionEngine - by pMachine
	-----------------------------------------------------
	http://www.pmachine.com/
-----------------------------------------------------
	Copyright (c) 2003 - 2004 pMachine, Inc.
	=====================================================
	THIS IS COPYRIGHTED SOFTWARE
	PLEASE READ THE LICENSE AGREEMENT
	http://www.pmachine.com/expressionengine/license.html
=====================================================
	File: mcp.selecteditems.php
	-----------------------------------------------------
	Purpose: SelectedItems module - CP
	=====================================================
	*/

class SelectedItems_CP {

	var $version		= '1.4';
	var $module_name = "selecteditems";

	// -------------------------
	//  Constructor
	// -------------------------

	function SelectedItems_CP( $switch = TRUE )
	{
		global $IN, $DB;

		// Upgrade module if necessary
		$query = $DB->query( "SELECT module_version FROM exp_modules WHERE module_name = 'Selecteditems'" );
		if( $query->num_rows > 0 ) {
			if( $query->row['module_version'] != $this->version )
			{
				$DB->query("UPDATE exp_modules SET module_version='".$this->version."' WHERE module_name='Selecteditems'");
			}
			if ( $query->row['module_version'] < "1.1" ) {
				// Add new field to table to remember form settings
				$DB->query("ALTER TABLE `exp_selecteditems` ADD `selecteditems_form` TEXT;");
			}
			if ( $query->row['module_version'] < "1.2" ) {
				// Add new action to move ajax call into extension file
				$DB->query("INSERT INTO exp_actions (action_id, class, method) VALUES ( '', 'SelectedItems_CP', 'ajax_update_entries')" );
			}
			if ( $query->row['module_version'] < "1.3" ) {
				// Add new field to table to remember site id
				$DB->query("ALTER TABLE `exp_selecteditems` ADD `selecteditems_site_id` INT(4) UNSIGNED NOT NULL DEFAULT 1;");
			}
			if ( $query->row['module_version'] < "1.4" ) {
				// Remove action from exp_action table - javascript moved external to CP
				$DB->query("DELETE FROM exp_actions WHERE class='SelectedItems_CP';");
			}
		}

		if ($switch)
		{
			switch($IN->GBL('P'))
			{
				case 'modify' : $this->modify_selecteditems();
				break; 
				case 'update' : $this->update_selecteditems();
				break;
				case 'delete' : $this->delete_selecteditems();
				break;
				case 'get_entries' : $this->ajax_update_entries();
				break;

				default : $this->selecteditems_home();
				break;
			}
		}
	}
	// END


	// ----------------------------------------
	//  Module Homepage
	// ----------------------------------------

	function selecteditems_home($msg='')
	{
		global $DSP, $LANG, $FNS, $DB, $PREFS;

		$query = $DB->query("SELECT * FROM exp_selecteditems WHERE selecteditems_site_id = " . $DB->escape_str($PREFS->ini('site_id')));
		if ($query->num_rows == 0)
		{
			// $DSP->body .= $DSP->error_message($LANG->line('no_selecteditemss'));        
			// return;
		}

		$DSP->title = $LANG->line('selecteditems_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=selecteditems',
			$LANG->line('selecteditems_module_name'));

		$DSP->crumb .= $DSP->crumb_item('Crumb');    

		// 

		$DSP->right_crumb( 
			$LANG->line('selecteditems_create_new'), 
			BASE.AMP.'C=modules'.AMP.'M=selecteditems'.AMP.'P=modify'
		);

		// -------------------------------------------------------
		//   Heading and Success Message, if any
		// -------------------------------------------------------

		$r = $DSP->qdiv( 'tableHeading', $LANG->line('selecteditems_view') ); 

		if ($msg != '')
		{
			$r .= $DSP->qdiv( 'successBox', $DSP->qdiv('success', $msg) );
		}


		// -------------------------------------------------------
		//  Table and Table Headers
		// -------------------------------------------------------

		$r .= $DSP->table('tableBorder', '0', '0', '100%') .
			$DSP->tr() .
			$DSP->table_qcell('tableHeadingAlt', 
				array(
					$LANG->line('selecteditems_id'),
					$LANG->line('selecteditems_name'),
					$LANG->line('selecteditems_description'),
					''
				)
			) .
			$DSP->tr_c();

		$i = 0;

		// -------------------------------------------------------
		//  Display Rows
		// -------------------------------------------------------

		if ($query->num_rows == 0)
		{
			$r .= $DSP->tr() . 
				$DSP->td('tableCellOne', "100%", 3) . 
				$DSP->anchor(
					BASE.AMP.'C=modules'.AMP.'M=selecteditems'.AMP.'P=modify',
					$LANG->line('selecteditems_create_new')
				) . 
				$DSP->td_c() . 
				$DSP->tr_c();
		}

		foreach($query->result as $row)
		{
			$style = ($i++ % 2) ? 'tableCellOne' : 'tableCellTwo';

			$r .= $DSP->tr();

			$r .= $DSP->table_qcell($style, $row['selecteditems_id'],'','top');
			$r .= $DSP->table_qcell($style, $DSP->anchor(BASE.
				AMP.'C=modules'.
				AMP.'M=selecteditems'.
				AMP.'P=modify'.
				AMP.'selecteditems_id='.
				$row['selecteditems_id'],
				$row['selecteditems_name'] ),
				'', 'top');
			$r .= $DSP->table_qcell($style, $row['selecteditems_description'],'','top');


			$r .= $DSP->table_qcell($style, $DSP->anchor(BASE.
				AMP.'C=modules'.
				AMP.'M=selecteditems'.
				AMP.'P=delete'.
				AMP.'selecteditems_id='.
				$row['selecteditems_id'],
				$LANG->line('selecteditems_delete')),'15%','top');

			$r .= $DSP->tr_c();

		}

		// -------------------------------------------------------
		//  Close Table and Output to $DSP->body
		// -------------------------------------------------------

		$r .= $DSP->table_c();

		$r .= '<p><a href="http://www.brandnewbox.co.uk/docs/">Documentation</a></p>';

		$DSP->body .= $r;

	}


	function modify_selecteditems($msg='')
	{
		global $DSP, $LANG, $DB, $FNS, $IN, $PREFS, $SESS;

		// -------------------------------------------------------
		//  If Modfying Existing selecteditems, Retrieve Text
		// -------------------------------------------------------

		if ( ! $IN->GBL('selecteditems_id'))
		{
			$selecteditems_name = '';
			$selecteditems_description = '';
			$selecteditems_cache = '';
		}
		else
		{
			$query = $DB->query("SELECT selecteditems_name, 
				selecteditems_description, 
				selecteditems_cache, 
				selecteditems_form
				FROM exp_selecteditems
				WHERE selecteditems_id = '".$IN->GBL('selecteditems_id')."'
				AND selecteditems_site_id = '" . $DB->escape_str($PREFS->ini('site_id')) . "'"
			);

			if ($query->num_rows == 0)
			{
				$DSP->body .= $DSP->error_message('ERROR');        
				return;
			}

			$selecteditems_name = $query->row['selecteditems_name'];
			$selecteditems_description = $query->row['selecteditems_description'];
			$selecteditems_cache = $query->row['selecteditems_cache'];
			$selecteditems_form = unserialize( $query->row['selecteditems_form'] );
		}

		// -------------------------------------------------------
		//  HTML Title and Navigation Crumblinks
		// -------------------------------------------------------

		$DSP->title = $LANG->line('selecteditems_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=selecteditems',
			$LANG->line('selecteditems_module_name'));       

		$DSP->crumb .= $DSP->crumb_item(($selecteditems_name != '') ? 
			$LANG->line('selecteditems_update') : 
			$LANG->line('selecteditems_create_new') ); 

		$DSP->extra_header .= '<link rel="stylesheet" type="text/css" media="screen" href="modules/selecteditems/css/selecteditems.css" ></link>';
		$DSP->extra_header .= '<script type="text/javascript" src="modules/selecteditems/js/selecteditems.js"></script>';

		$DSP->right_crumb( $LANG->line('selecteditems_view'), BASE.AMP.'C=modules'.AMP.'M=selecteditems'.AMP.'P=view');

		// -------------------------------------------------------
		// Declare Form
		// -------------------------------------------------------

		$r = $DSP->form('C=modules'.AMP.'M=selecteditems'.AMP.'P=update', 'target');

		// -------------------------------------------------------
		//  Modifying Existing selecteditems, Hidden Form Field for ID
		// -------------------------------------------------------

		if ($selecteditems_name != '')
		{
			$r .= $DSP->input_hidden('selecteditems_id', $IN->GBL('selecteditems_id')); 
		}

		$r .= $DSP->input_hidden('basepath', BASE. "&C=modules&M=selecteditems&P=get_entries");

		// -------------------------------------------------------
		//  Table For Form
		// -------------------------------------------------------

		$r .= $DSP->qdiv( 'tableHeading', ($selecteditems_name != '') ? $LANG->line('selecteditems_update') : $LANG->line('selecteditems_create_new') ); 

		$message = $this->_get_flashdata( "message" );
		if ( $message != "" ) {
			$r .= $DSP->qdiv( 'successBox', $DSP->qdiv('success', $message ) );
			$r .= '<script type="text/javascript">setTimeout( function(){ $(".successBox").slideUp(); }, 3000);</script>';
		}

		$r .= $DSP->table('tableBorder', '0', '0', '100%');

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', $LANG->line('selecteditems_name') ),
			'30%'
		);
		$r .= $DSP->table_qcell(
			'tableCellTwo', 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text(
						'selecteditems_name', 
						$selecteditems_name, '35', '40', 'input', '45%')
					)
				), 
			'70%'
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold', $LANG->line('selecteditems_description')
			), 
			'30%'
		);
		$r .= $DSP->table_qcell(
			'tableCellOne', 
			$DSP->qdiv('defaultBold',
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text(
						'selecteditems_description', 
						$selecteditems_description, '64', '255', 'input', ''
					)
				)
			), 
			'70%'
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr() . $DSP->td('tableCellTwo', "100%", 2);

		$r .= '
			<table>

			<tr>
			<th>' . $LANG->line('selecteditems_source') . '</th>
			<th></th>
			<th>' . $LANG->line('selecteditems_selection') . '</th>
			</tr>

			<tr valign="top">
			<td>
			<select id="sourceList" class="selection" name="sourceList" multiple="multiple" size="10">
			';	    				
		$r .= '	 						</select><br/><br/>
			';

		$r .= "<p>";

		$r .= $LANG->line('selecteditems_filter') . ": " . 
			$DSP->input_text(
				'filter', 
				( isset( $selecteditems_form[ "filter" ] ) ? $selecteditems_form[ "filter" ] : ''), '40', '200', 'input', '200px'
			);

		$r .= "</p><p>";

		$allowed_blogs = $FNS->fetch_assigned_weblogs();

		$weblog_id = '';
		$cat_group = '';
		$sql = "SELECT blog_title, weblog_id, cat_group FROM exp_weblogs";

		// If the user is restricted to specific blogs, add that to the query

		$s = $LANG->line('selecteditems_weblog') . 
			": <select name='weblog_id' class='select'>\n";

		$where = array();

		if ( count($allowed_blogs) > 0 ) {
			$where[] = " weblog_id IN (" . join(",", $allowed_blogs) . ")";
		} else {
			$where[] = " weblog_id = 0"; // ie, never return anything
		}

		$where[] = "site_id = ".$DB->escape_str($PREFS->ini('site_id'));

		$sql .= " WHERE " . join(" AND ", $where);

		$sql .= " ORDER BY blog_title";

		$query = $DB->query($sql);

		if ($query->num_rows == 1)
		{
			$weblog_id = $query->row['weblog_id'];
			$cat_group = $query->row['cat_group'];
		}
		elseif($weblog_id != '')
		{
			foreach($query->result as $row)
			{
				if ($row['weblog_id'] == $weblog_id)
				{
					$weblog_id = $row['weblog_id'];
					$cat_group = $row['cat_group'];
				}
			}
		}

		if ($query->num_rows > 1)
		{
			$s .= $DSP->input_select_option('',  $LANG->line('all'));
		}
		if ($query->num_rows == 0)
		{
			$s .= $DSP->input_select_option('0',
				$LANG->line('selecteditems_no_weblogs_assigned') );	
		}

		$selected = '';

		foreach ($query->result as $row)
		{
			$selected = isset( $selecteditems_form ) && ( $selecteditems_form[ "weblog_id" ] == $row['weblog_id'] ) ? 'y' : '';
			$s .= $DSP->input_select_option($row['weblog_id'], $row['blog_title'], $selected);
		}        

		$s .= $DSP->input_select_footer().
			$DSP->nbs(2);

		$r .= $s . "</p><p>";

		$weblog_id = '';
		$cat_group = '';
		$sql = "SELECT cat_id, cat_name FROM exp_categories";

		// If the user is restricted to specific blogs, add that to the query        
		$s = $LANG->line('selecteditems_categories') . 
			": <select name='category' class='select'>\n";

		$sql .= " WHERE site_id = '". $DB->escape_str($PREFS->ini('site_id'))."' ORDER BY group_id, cat_order";

		$query = $DB->query($sql);

		if ($query->num_rows > 1)
		{
			$s .= $DSP->input_select_option('',  $LANG->line('all'));
		}

		foreach ($query->result as $row)
		{
			$selected = isset( $selecteditems_form ) && ( $selecteditems_form[ "category" ] == $row['cat_id'] ) ? 'y' : '';
			$s .= $DSP->input_select_option($row['cat_id'], $row['cat_name'], $selected);
		}        

		$s .= $DSP->input_select_footer().
			$DSP->nbs(2);

		$r .= $s . "</p><p>";

		$perpage = isset( $selecteditems_form[ "perpage" ] ) ? $selecteditems_form[ "perpage" ] : '';
		; 
		$r .= $LANG->line('selecteditems_results') . ": " . $DSP->input_select_header('perpage').
			$DSP->input_select_option('', 'All entries', ($perpage == '')  ? 1 : '').
			$DSP->input_select_option('5', '5 entries', ($perpage == 5)  ? 1 : '').
			$DSP->input_select_option('10', '10 entries', ($perpage == 10)  ? 1 : '').
			$DSP->input_select_option('25', '25 entries', ($perpage == 25)  ? 1 : '').
			$DSP->input_select_option('50', '50 entries', ($perpage == 50)  ? 1 : '').
			$DSP->input_select_footer();

		$r .= "</p><p>";

		$order = isset( $selecteditems_form[ "order" ] ) ? $selecteditems_form[ "order" ] : '';

		$r .= $LANG->line('selecteditems_order') . ": " . $DSP->input_select_header('order').
			$DSP->input_select_option('entry_date DESC', 'Date (newest first)', ($order == 'entry_date DESC')  ? 1 : '').
			$DSP->input_select_option('entry_date ASC', 'Date (oldest first)', ($order == 'entry_date ASC')  ? 1 : '').
			$DSP->input_select_option('title ASC', 'Title', ($order == 'title ASC')  ? 1 : '').
			$DSP->input_select_option('entry_id DESC', 'Entry ID (newest first)', ($order == 'entry_id DESC')  ? 1 : '').
			$DSP->input_select_option('entry_id ASC', 'Entry ID (oldest first)', ($order == 'entry_id ASC')  ? 1 : '').
			$DSP->input_select_footer();


		$r .= '							<br/><br/><input class="button" name="update" type="button" value="' . $LANG->line('selecteditems_filter_submit') . '" onclick="updateSource()" />&nbsp;<span id="filterSubmitImage">Loading...</span>

			</td>
			<td>
			<input class="button" name="add" type="button" value="' . $LANG->line('selecteditems_add') . '" onclick="addItem()" /><br/>
			<input class="button" name="remove" type="button" value="' . $LANG->line('selecteditems_remove') . '" onclick="removeItem() "/>
			</td>
			<td align="center">
			<select id="selectedList" class="selection" name="selectedList" multiple="multiple" size="10">
			';

		/* Modifying an existing entry */
		if ($selecteditems_cache != '')
		{      
			$rows = $DB->query("SELECT entry_id, title FROM exp_weblog_titles t WHERE entry_id IN (" . $selecteditems_cache . ")" );
			foreach ( split( ",", $selecteditems_cache ) as $id ) {
				foreach ( $rows->result as $row ) {
					if ( $row[ "entry_id" ] == $id ) {
						$r .= '<option value="' . $row[ "entry_id" ] . '">' /* . $row[ "entry_id" ] . ") " */ . $row[ "title" ] . '</option>';
					}
				}
			}
		}

		$r .= '	    				</select>
			<br/><br/>
			<input class="button" name="up" type="button" value="' . $LANG->line('selecteditems_moveup') . '" onclick="moveOptionUp()" /><br/>
			<input class="button" name="down" type="button" value="' . $LANG->line('selecteditems_movedown') . '" onclick="moveOptionDown()" />
			</td>
			</tr>

			</table>

			<input id="selecteditems_list" type="hidden" name="selecteditems_list" value="'.$selecteditems_cache.'" />
			';

		$r .= $DSP->td_c() . $DSP->tr_c() . $DSP->table_c();

		// -------------------------------------------------------
		//  Submit Button Text - Add/Update
		// -------------------------------------------------------

		if ($selecteditems_name != '')
		{
			$r .= $DSP->qdiv('itemWrapper', BR.$DSP->input_submit($LANG->line('selecteditems_update')));    
		}
		else
		{
			$r .= $DSP->qdiv('itemWrapper', BR.$DSP->input_submit($LANG->line('selecteditems_create_new')));  
		}

		// -------------------------------------------------------
		//  Close Form
		// -------------------------------------------------------

		$r .= $DSP->form_c();

		$DSP->body .= $r;  

	}
	// END

	// -------------------------
	// Update/Create group
	// -------------------------

	function update_selecteditems()
	{
		global $LANG, $DB, $IN, $DSP, $FNS, $REGX, $PREFS, $SESS;

		$form_vars = array (
			"filter" => $_POST[ "filter" ], 
			"weblog_id" => $_POST[ "weblog_id" ], 
			"category" => $_POST[ "category" ], 
			"perpage" => $_POST[ "perpage" ], 
			);

		// -------------------------------------------------------
		//  Valid selecteditems Text Received?
		// -------------------------------------------------------

		$selecteditems_name = ( ! isset($_POST['selecteditems_name'])) ? '' : trim($_POST['selecteditems_name']);

		if ($selecteditems_name == '')
		{
			$DSP->body .= $DSP->error_message($LANG->line('selecteditems_error_no_name'));        
			return;
		} 

		$selecteditems_description = ( ! isset($_POST['selecteditems_description'])) ? '' : trim($_POST['selecteditems_description']);

		/*
			$selecteditems_cache = ( ! isset($_POST['selecteditems_cache'])) ? '' : trim($_POST['selecteditems_cache']);
		if ($selecteditems_cache == '')
		{
			$DSP->body .= $DSP->error_message('Error');        
			return;
		} 
		*/

		$selecteditems_cache = ( ! isset($_POST['selecteditems_list'])) ? '' : trim($_POST['selecteditems_list']);

		// -------------------------------------------------------
		//  Insert or Update Depending on selecteditems ID
		// -------------------------------------------------------

		if ( ! isset($_POST['selecteditems_id']))
		{
			$data = array('selecteditems_id'		=> '',
				'selecteditems_name'	=> trim($selecteditems_name),
				'selecteditems_description'	=> trim($selecteditems_description),
				'selecteditems_cache'	=> trim($selecteditems_cache),
				'selecteditems_form'	=> serialize($form_vars),
				'selecteditems_site_id' => $PREFS->ini('site_id')
				);

			$DB->query($DB->insert_string('exp_selecteditems', $data));

			// ---------------------------------------------------
			//  Return to Form with Success Message
			// ---------------------------------------------------

			return $this->selecteditems_home($LANG->line('selecteditems_added'));
		}
		else
		{

			// DO UPDATE

			$data = array(
				'selecteditems_name'	=> trim($selecteditems_name),
				'selecteditems_description'	=> trim($selecteditems_description),
				'selecteditems_cache'	=> trim($selecteditems_cache), 
				'selecteditems_form'	=> serialize($form_vars)
				);

			$DB->query($DB->update_string('exp_selecteditems', $data, "selecteditems_id ='".$IN->GBL("selecteditems_id")."'"));	

			// ---------------------------------------------------
			//  Return to View selecteditems with Success Message
			// ---------------------------------------------------

			$this->_set_flashdata( "message", $LANG->line('selecteditems_updated') );

			$cp_url = BASE.'&C=modules'.AMP.'M=selecteditems'.AMP.'P=modify'.AMP.'selecteditems_id='.$IN->GBL("selecteditems_id") .AMP.'saved=ok';
			$FNS->redirect( $cp_url );

			// return $this->modify_selecteditems($LANG->line('selecteditems_updated'));
		}

	}
	// END

	// -------------------------
	// Delete selecteditems
	// -------------------------

	function delete_selecteditems()
	{
		global $LANG, $DB, $IN, $DSP;

		// -------------------------------------------------------
		//  selecteditems ID is required
		// -------------------------------------------------------

		if ( ! $IN->GBL('selecteditems_id'))
		{
			$DSP->body .= $DSP->error_message('Error');        
			return;
		}
		else
		{
			$query = $DB->query("DELETE FROM exp_selecteditems
			WHERE selecteditems_id = '".$IN->GBL('selecteditems_id')."'");

		if ($DB->affected_rows == 0)
		{
			$DSP->body .= $DSP->error_message('Error');
			return;
		}
	}

	// -------------------------------------------------------
	//  Return to View selecteditemss with Success Message
	// -------------------------------------------------------

	return $this->selecteditems_home($LANG->line('selecteditems_deleted') );
	}
	// END


	function ajax_update_entries() {

		$r = "";

		header("Content-type:text/xml");

		echo "<select>";

		$sql = "SELECT t.entry_id, t.weblog_id, t.title FROM exp_weblog_titles AS t, exp_weblog_data AS d";

		if ( $_GET[ "category" ] != "" ) {
			$sql .= ", exp_category_posts c";
		}

		$sql .= " WHERE t.entry_id=d.entry_id";

		if ( $_GET[ "category" ] != "" ) {
			$sql .= " AND c.entry_id = t.entry_id AND c.cat_id =".mysql_real_escape_string( $_GET[ "category" ] );
		}
		if ( $_GET[ "filter" ] != "" ) {
			$sql .= " AND title LIKE '%".mysql_real_escape_string( $_GET[ "filter" ] ) ."%' ";
		}
		if ( $_GET[ "weblog_id" ] != "" ) {
			$sql .= " AND t.weblog_id = '".mysql_real_escape_string( $_GET[ "weblog_id" ] ) ."'";
		}

		if ( $_GET[ "order" ] != "" ) {
			$sql .= " ORDER BY t." . $_GET[ "order" ];
		}

		if ( $_GET[ "perpage" ] != "" ) {
			$sql .= " LIMIT " . mysql_real_escape_string( $_GET[ "perpage" ] );
		}

		// print $sql;

		$query = mysql_query( $sql );
		while( $entries = mysql_fetch_assoc( $query ) ) {

			$r .= '<option value="' . htmlspecialchars( $entries[ "entry_id" ] ) . '">' . htmlspecialchars( $entries[ "title" ] ) . '</option>' . "\n";

		}

		echo $r;

		echo "</select>";

		exit;

	}

	// ----------------------------------------
	//  Private functions
	// ----------------------------------------

	function _set_flashdata( $key, $data ) {
		session_start();
		if ( !isset( $_SESSION[ $this->module_name ] ) ) {
			$_SESSION[ $this->module_name ] = array();
		}
		$_SESSION[ $this->module_name ][ $key ] = $data;		
	}

	function _get_flashdata( $key, $keep = FALSE ) {
		session_start();  
		if( isset( $_SESSION[ $this->module_name ] ) ) {
			if( isset( $_SESSION[ $this->module_name ][ $key ] ) ) {
				$data = $_SESSION[ $this->module_name ][ $key ];
				if ( $keep != TRUE ) {
		    	unset($_SESSION[ $this->module_name ][ $key ]); 
		    	unset($_SESSION[ $this->module_name ]); 
				}
				return( $data );
			}
		}
		return "";
	}


	// ----------------------------------------
	//  Module installer
	// ----------------------------------------

	function selecteditems_module_install()
	{
		global $DB;        

		$sql[] = "INSERT INTO exp_modules (module_id, 
			module_name, 
			module_version, 
		has_cp_backend) 
		VALUES 
	('', 
		'Selecteditems', 
		'$this->version', 
	'y')";

	$sql[] = "CREATE TABLE IF NOT EXISTS `exp_selecteditems` (
	`selecteditems_id` INT(6) UNSIGNED NOT NULL AUTO_INCREMENT,
	`selecteditems_name` VARCHAR(255), 
	`selecteditems_description` TEXT NOT NULL,
	`selecteditems_cache` TEXT, 
	`selecteditems_form` TEXT,
	`selecteditems_site_id` INT(4) UNSIGNED NOT NULL DEFAULT 1,
	PRIMARY KEY (`selecteditems_id`));";

	$sql[] = "INSERT INTO exp_selecteditems (selecteditems_id, 
		selecteditems_name, 
		selecteditems_description, 
		selecteditems_cache, 
	selecteditems_form) 
	VALUES 
	('', 
		'Test', 
		'Blah, blah, blah...', 
	'', '')";

	foreach ($sql as $query)
	{
		$DB->query($query);
	}

	return true;
	}
	// END    

	// ----------------------------------------
	//  Module de-installer
	// ----------------------------------------

	function selecteditems_module_deinstall()
	{
		global $DB;    

		$query = $DB->query("SELECT module_id
			FROM exp_modules 
		WHERE module_name = 'Selecteditems'"); 

	$sql[] = "DELETE FROM exp_modules 
		WHERE module_name = 'selecteditems'";

	$sql[] = "DROP TABLE IF EXISTS exp_selecteditems";

	foreach ($sql as $query)
	{
		$DB->query($query);
	}

	return true;
	}
	// END

	}
	// END CLASS
?>